import type * as emmet from '@vscode/emmet-helper';
import * as vscode from 'vscode-languageserver';
import type { TextDocument } from 'vscode-languageserver-textdocument';
import type * as css from 'vscode-css-languageservice';
import type * as html from 'vscode-html-languageservice';
import type * as vue from 'vscode-vue-languageservice';
import type * as ts from 'typescript/lib/tsserverlibrary';
export declare function createLsConfigs(rootFolders: string[], connection: vscode.Connection): {
    getCodeLensConfigs: () => Promise<{
        references: boolean;
        pugTool: boolean;
        scriptSetupTool: boolean;
    }>;
    getEmmetConfiguration: (syntax: string) => Promise<emmet.VSCodeEmmetConfig>;
    getCssLanguageSettings: (textDocument: TextDocument) => Promise<css.LanguageSettings>;
    getTsPreferences: (textDocument: TextDocument) => Promise<ts.UserPreferences>;
    getTsFormatOptions: (textDocument: TextDocument, options?: vscode.FormattingOptions | undefined) => Promise<ts.FormatCodeSettings>;
    getHtmlHoverSettings: (textDocument: TextDocument) => Promise<html.HoverSettings>;
    registerCustomData: (vueLs: vue.LanguageService) => Promise<void>;
};
